/**
  **************************************************************************************************
  * @file		ascii.h
  * @author		Kerem Yollu
  * @date		04.11.2021
  * @version	1.0
  ************************************************************************************************** 
  * @brief		Defines ofr ascii chars. 	
  * 
  **************************************************************************************************
*/

#ifndef _ASCII_H_
#define _ASCII_H_

#ifdef __cplusplus
extern "C" {
#endif
#define ASCII_NULL	0   // Null character 
#define ASCII_SOH	1   // Start of Header 
#define ASCII_STX	2   // Start of Text 
#define ASCII_ETX	3   // End of Text, hearts card suit 
#define ASCII_EOT	4   // End of Transmission, diamonds card suit 
#define ASCII_ENQ	5   // Enquiry, clubs card suit 
#define ASCII_ACK	6   // Acknowledgement, spade card suit 
#define ASCII_BEL	7   // Bell 
#define ASCII_BS	8   // Backspace 
#define ASCII_HT	9   // Horizontal Tab 
#define ASCII_LF	10  // Line feed 
#define ASCII_VT	11  // Vertical Tab, male symbol, symbol for Mars 
#define ASCII_FF	12  // Form feed, female symbol, symbol for Venus 
#define ASCII_CR	13  // Carriage return 
#define ASCII_SO	14  // Shift Out 
#define ASCII_SI	15  // Shift In 
#define ASCII_DLE	16  // Data link escape 
#define ASCII_DC1	17  // Device control 1 
#define ASCII_DC2	18  // Device control 2 
#define ASCII_DC3	19  // Device control 3 
#define ASCII_DC4	20  // Device control 4 
#define ASCII_NAK	21  // NAK Negative-acknowledge 
#define ASCII_SYN	22  // Synchronous idle 
#define ASCII_ETB	23  // End of trans. block 
#define ASCII_CAN	24  // Cancel 
#define ASCII_EM	25  // End of medium 
#define ASCII_SUB	26  // Substitute 
#define ASCII_ESC	27  // Escape 
#define ASCII_FS	28  // File separator 
#define ASCII_GS	29  // Group separator 
#define ASCII_RS	30  // Record separator 
#define ASCII_US	31  // Unit separator 
#define ASCII_DEL	127 // Delete 
#define ASCII_space	32  // Space 
#define ASCII_nbsp	255 // Non-breaking space or no-break space 
#define ASCII_clear	"\033[2J" // Clear screen command 

#ifdef __cplusplus
}
#endif

#endif // _ASCII_H_
